#pragma once
/*
 *  Copyright (C) 2024  Brett Terpstra
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef BLT_GRAPHICS_POST_PROCESS_H
#define BLT_GRAPHICS_POST_PROCESS_H

#include <blt/std/types.h>
#include <blt/gfx/framebuffer.h>
#include <blt/gfx/shader.h>
#include <blt/gfx/model.h>
#include <vector>
#include <memory>

namespace blt::gfx
{
    namespace detail
    {
        class pp_link;
        
        class pp_iterator;
        
        class pp_link
        {
            public:
            
            private:
            
        };
        
        class pp_iterator
        {
            public:
            
            private:
            
        };
    }
    
    class pp_step
    {
        public:
            virtual void create(i32 width, i32 height) = 0;
            
            virtual void draw(i32 width, i32 height) = 0;
            
            frame_buffer_t& getBuffer()
            {
                return draw_buffer;
            }
        
        protected:
            frame_buffer_t draw_buffer;
    };
    
    class pp_engine
    {
        public:
            void create();
            
            void render(i32 width, i32 height);
        
        private:
            std::vector<std::unique_ptr<pp_step>> steps;
            shader_t screen_shader;
            
    };
}

#endif //BLT_GRAPHICS_POST_PROCESS_H
